]> git.saurik.com Git - apt.git/blob - test/integration/framework
tests: enhance output of grep and test fails
[apt.git] / test / integration / framework
1 #!/bin/sh -- # no runable script, just for vi
2
3 EXIT_CODE=0
4
5 # we all like colorful messages
6 if [ "$MSGCOLOR" != 'NO' ]; then
7 if [ ! -t 1 ]; then # but check that we output to a terminal
8 export MSGCOLOR='NO'
9 fi
10 fi
11
12
13 if [ "$MSGCOLOR" != 'NO' ]; then
14 CERROR="\033[1;31m" # red
15 CWARNING="\033[1;33m" # yellow
16 CMSG="\033[1;32m" # green
17 CINFO="\033[1;96m" # light blue
18 CDEBUG="\033[1;94m" # blue
19 CNORMAL="\033[0;39m" # default system console color
20 CDONE="\033[1;32m" # green
21 CPASS="\033[1;32m" # green
22 CFAIL="\033[1;31m" # red
23 CCMD="\033[1;35m" # pink
24 fi
25
26 msgprintf() {
27 local START="$1"
28 local MIDDLE="$2"
29 local END="$3"
30 shift 3
31 if [ -n "$1" ]; then
32 printf "$START " "$1"
33 shift
34 while [ -n "$1" ]; do
35 printf "$MIDDLE " "$(echo "$1" | sed -e 's#^apt\([cfghs]\)#apt-\1#')"
36 shift
37 done
38 fi
39 printf "${END}"
40 }
41 msgdie() { msgprintf "${CERROR}E: %s" '%s' "${CNORMAL}\n" "$@" >&2; exit 1; }
42 msgwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}\n" "$@" >&2; }
43 msgmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}\n" "$@"; }
44 msginfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}\n" "$@"; }
45 msgdebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}\n" "$@"; }
46 msgdone() { msgprintf "${CDONE}DONE" '%s' "${CNORMAL}\n" "$@"; }
47 msgnwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}" "$@" >&2; }
48 msgnmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@"; }
49 msgninfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}" "$@"; }
50 msgndebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; }
51 msgtest() { msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; }
52 msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
53 msgskip() {
54 if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2;
55 else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi
56 }
57 msgfail() {
58 if [ $# -gt 0 ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
59 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
60 if [ -n "$APT_DEBUG_TESTS" ]; then
61 $SHELL
62 fi
63 EXIT_CODE=$((EXIT_CODE+1));
64 }
65
66 # enable / disable Debugging
67 MSGLEVEL=${MSGLEVEL:-3}
68 if [ $MSGLEVEL -le 0 ]; then
69 msgdie() { true; }
70 fi
71 if [ $MSGLEVEL -le 1 ]; then
72 msgwarn() { true; }
73 msgnwarn() { true; }
74 fi
75 if [ $MSGLEVEL -le 2 ]; then
76 msgmsg() { true; }
77 msgnmsg() { true; }
78 msgtest() { true; }
79 msgpass() { printf " ${CPASS}P${CNORMAL}"; }
80 fi
81 if [ $MSGLEVEL -le 3 ]; then
82 msginfo() { true; }
83 msgninfo() { true; }
84 fi
85 if [ $MSGLEVEL -le 4 ]; then
86 msgdebug() { true; }
87 msgndebug() { true; }
88 fi
89 msgdone() {
90 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
91 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
92 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
93 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
94 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
95 true;
96 else
97 printf "${CDONE}DONE${CNORMAL}\n";
98 fi
99 }
100 getaptconfig() {
101 if [ -f ./aptconfig.conf ]; then
102 echo "./aptconfig.conf"
103 elif [ -f ../aptconfig.conf ]; then
104 echo "../aptconfig.conf"
105 fi
106 }
107 runapt() {
108 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
109 local CMD="$1"
110 shift
111 case $CMD in
112 sh|aptitude|*/*|command) ;;
113 *) CMD="${BUILDDIRECTORY}/$CMD";;
114 esac
115 MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH=${LIBRARYPATH} $CMD "$@"
116 }
117 aptconfig() { runapt apt-config "$@"; }
118 aptcache() { runapt apt-cache "$@"; }
119 aptcdrom() { runapt apt-cdrom "$@"; }
120 aptget() { runapt apt-get "$@"; }
121 aptftparchive() { runapt apt-ftparchive "$@"; }
122 aptkey() { runapt apt-key "$@"; }
123 aptmark() { runapt apt-mark "$@"; }
124 aptsortpkgs() { runapt apt-sortpkgs "$@"; }
125 apt() { runapt apt "$@"; }
126 apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; }
127 aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
128 aptitude() { runapt aptitude "$@"; }
129 aptextracttemplates() { runapt apt-extracttemplates "$@"; }
130 aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; }
131
132 dpkg() {
133 command dpkg --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log "$@"
134 }
135 dpkgcheckbuilddeps() {
136 command dpkg-checkbuilddeps --admindir=${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg "$@"
137 }
138 gdb() {
139 local CMD="$1"
140 shift
141 runapt command gdb --quiet -ex run "${BUILDDIRECTORY}/$CMD" --args "${BUILDDIRECTORY}/$CMD" "$@"
142 }
143
144 exitwithstatus() {
145 # error if we about to overflow, but ...
146 # "255 failures ought to be enough for everybody"
147 if [ $EXIT_CODE -gt 255 ]; then
148 msgdie "Total failure count $EXIT_CODE too big"
149 fi
150 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
151 }
152
153 shellsetedetector() {
154 local exit_status=$?
155 if [ "$exit_status" != '0' ]; then
156 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
157 if [ "$EXIT_CODE" = '0' ]; then
158 EXIT_CODE="$exit_status"
159 fi
160 fi
161 }
162
163 addtrap() {
164 if [ "$1" = 'prefix' ]; then
165 CURRENTTRAP="$2 $CURRENTTRAP"
166 else
167 CURRENTTRAP="$CURRENTTRAP $1"
168 fi
169 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
170 }
171
172 setupenvironment() {
173 # privilege dropping and testing doesn't work if /tmp isn't world-writeable (as e.g. with libpam-tmpdir)
174 if [ -n "$TMPDIR" ] && [ "$(id -u)" = '0' ] && [ "$(stat --format '%a' "$TMPDIR")" != '1777' ]; then
175 unset TMPDIR
176 fi
177 TMPWORKINGDIRECTORY=$(mktemp -d)
178 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY;"
179 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
180
181 mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded"
182 if [ "$(id -u)" = '0' ]; then
183 # relax permissions so that running as root with user switching works
184 umask 022
185 chmod 711 "$TMPWORKINGDIRECTORY"
186 chown _apt:root "${TMPWORKINGDIRECTORY}/downloaded"
187 fi
188
189 TESTDIRECTORY=$(readlink -f $(dirname $0))
190 # allow overriding the default BUILDDIR location
191 BUILDDIRECTORY=${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}
192 LIBRARYPATH=${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}
193 METHODSDIR=${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}
194 APTHELPERBINDIR=${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}
195 APTWEBSERVERBINDIR=${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}
196 APTINTERNALSOLVER=${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}
197 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
198 # -----
199
200 cd $TMPWORKINGDIRECTORY
201 mkdir rootdir aptarchive keys
202 cd rootdir
203 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
204 mkdir -p usr/bin var/cache var/lib/apt var/log tmp
205 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
206 touch var/lib/dpkg/available
207 mkdir -p usr/lib/apt
208 ln -s ${METHODSDIR} usr/lib/apt/methods
209 if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then
210 mkdir -p usr/lib/apt/solvers
211 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump
212 ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt
213 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc/apt/apt.conf.d/externalsolver.conf
214 fi
215 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
216 # system
217 if [ -e ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove ]; then
218 ln -s ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove etc/apt/apt.conf.d/01autoremove
219 else
220 ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove
221 fi
222 cd ..
223 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
224 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
225 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
226 fi
227 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
228 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
229 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
230 fi
231 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/
232 chmod 644 $(find keys -name '*.pub' -o -name '*.sec')
233 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
234
235 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
236 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
237 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
238 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
239 echo "Dir::Bin::Methods \"${METHODSDIR}\";" >> aptconfig.conf
240 # store apt-key were we can access it, even if we run it as a different user
241 # destroys coverage reporting though, so just do it for root for now
242 if [ "$(id -u)" = '0' ]; then
243 cp "${BUILDDIRECTORY}/apt-key" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/"
244 chmod o+rx "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key"
245 echo "Dir::Bin::apt-key \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key\";" >> aptconfig.conf
246 else
247 echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf
248 fi
249 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
250 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
251 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
252 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
253 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
254 if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then
255 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf # Added to test multiarch before dpkg is ready for it…
256 fi
257 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
258 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
259 echo 'quiet::NoStatistic "true";' >> aptconfig.conf
260 # too distracting for users, but helpful to detect changes
261 echo 'Acquire::Progress::Ignore::ShowErrorText "true";' >> aptconfig.conf
262 # in testcases, it can appear as if localhost has a rotation setup,
263 # hide this as we can't really deal with it properly
264 echo 'Acquire::Failure::ShowIP "false";' >> aptconfig.conf
265
266 cp "${TESTDIRECTORY}/apt.pem" "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
267 if [ "$(id -u)" = '0' ]; then
268 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
269 fi
270 echo "Acquire::https::CaInfo \"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem\";" > rootdir/etc/apt/apt.conf.d/99https
271 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary
272 configcompression '.' 'gz' #'bz2' 'lzma' 'xz'
273
274 # Acquire::AllowInsecureRepositories=false is not yet the default
275 # but we want it to be the default soon
276 configallowinsecurerepositories "false";
277
278 # cleanup the environment a bit
279 # prefer our apt binaries over the system apt binaries
280 export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
281 export LC_ALL=C.UTF-8
282 unset LANGUAGE APT_CONFIG
283 unset GREP_OPTIONS DEB_BUILD_PROFILES
284
285 msgdone "info"
286 }
287
288 getarchitecture() {
289 if [ "$1" = "native" -o -z "$1" ]; then
290 eval `aptconfig shell ARCH APT::Architecture`
291 if [ -n "$ARCH" ]; then
292 echo $ARCH
293 else
294 dpkg --print-architecture
295 fi
296 else
297 echo $1
298 fi
299 }
300
301 getarchitectures() {
302 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
303 }
304
305 getarchitecturesfromcommalist() {
306 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
307 }
308
309 configarchitecture() {
310 {
311 echo "APT::Architecture \"$(getarchitecture $1)\";"
312 while [ -n "$1" ]; do
313 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
314 shift
315 done
316 } >rootdir/etc/apt/apt.conf.d/01multiarch.conf
317 configdpkg
318 }
319
320 configdpkg() {
321 if [ ! -e rootdir/var/lib/dpkg/status ]; then
322 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
323 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
324 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
325 else
326 echo -n > rootdir/var/lib/dpkg/status
327 fi
328 fi
329 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
330 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
331 local ARCHS="$(getarchitectures)"
332 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
333 DPKGARCH="$(dpkg --print-architecture)"
334 for ARCH in ${ARCHS}; do
335 if [ "${ARCH}" != "${DPKGARCH}" ]; then
336 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
337 # old-style used e.g. in Ubuntu-P – and as it seems travis
338 echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
339 echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
340 fi
341 fi
342 done
343 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
344 # dpkg doesn't really check the version as long as it is fully installed,
345 # but just to be sure we choose one above the required version
346 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
347 fi
348 fi
349 fi
350 }
351
352 configallowinsecurerepositories() {
353 echo "Acquire::AllowInsecureRepositories \"$1\";" > rootdir/etc/apt/apt.conf.d/allow-insecure-repositories.conf
354
355 }
356
357 configcompression() {
358 while [ -n "$1" ]; do
359 case "$1" in
360 '.') printf ".\t.\tcat\n";;
361 'gz') printf "gzip\tgz\tgzip\n";;
362 'bz2') printf "bzip2\tbz2\tbzip2\n";;
363 'lzma') printf "lzma\tlzma\txz --format=lzma\n";;
364 'xz') printf "xz\txz\txz\n";;
365 *) printf "$1\t$1\t$1\n";;
366 esac
367 shift
368 done > ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf
369 }
370
371 forcecompressor() {
372 COMPRESSOR="$1"
373 COMPRESSOR_CMD="$1"
374 case $COMPRESSOR in
375 gzip) COMPRESS='gz';;
376 bzip2) COMPRESS='bz2';;
377 lzma) COMPRESS='lzma';;
378 xz) COMPRESS='xz';;
379 *) msgdie "Compressor $COMPRESSOR is unknown to framework, so can't be forced by forcecompressor!";;
380 esac
381 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
382 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
383 Dir::Bin::uncompressed \"/does/not/exist\";
384 Dir::Bin::gzip \"/does/not/exist\";
385 Dir::Bin::bzip2 \"/does/not/exist\";
386 Dir::Bin::lzma \"/does/not/exist\";
387 Dir::Bin::xz \"/does/not/exist\";" > "$CONFFILE"
388 if [ -e "/bin/${COMPRESSOR}" ]; then
389 echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> "$CONFFILE"
390 elif [ -e "/usr/bin/${COMPRESSOR}" ]; then
391 echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> "$CONFFILE"
392 elif [ "${COMPRESSOR}" = 'lzma' ]; then
393 echo 'Dir::Bin::xz "/usr/bin/xz";' >> "$CONFFILE"
394 COMPRESSOR_CMD='xz --format=lzma'
395 else
396 msgtest 'Test for availability of compressor' "${COMPRESSOR}"
397 msgfail
398 fi
399 }
400
401 setupsimplenativepackage() {
402 local NAME="$1"
403 local ARCH="$2"
404 local VERSION="$3"
405 local RELEASE="${4:-unstable}"
406 local DEPENDENCIES="$5"
407 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
408 If you find such a package installed on your system,
409 something went horribly wrong! They are autogenerated
410 und used only by testcases and surf no other propose…"}"
411
412 local SECTION="${7:-others}"
413 local DISTSECTION
414 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
415 DISTSECTION="main"
416 else
417 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
418 fi
419 local BUILDDIR=incoming/${NAME}-${VERSION}
420 mkdir -p ${BUILDDIR}/debian/source
421 cd ${BUILDDIR}
422 echo "* most suckless software product ever" > FEATURES
423 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
424 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
425
426 * Initial release
427
428 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
429 test -e debian/control || echo "Source: $NAME
430 Section: $SECTION
431 Priority: optional
432 Maintainer: Joe Sixpack <joe@example.org>
433 Build-Depends: debhelper (>= 7)
434 Standards-Version: 3.9.1
435
436 Package: $NAME" > debian/control
437 if [ "$ARCH" = 'all' ]; then
438 echo "Architecture: all" >> debian/control
439 else
440 echo "Architecture: any" >> debian/control
441 fi
442 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
443 echo "Description: $DESCRIPTION" >> debian/control
444
445 test -e debian/compat || echo "7" > debian/compat
446 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
447 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
448 cd - > /dev/null
449 }
450
451 buildsimplenativepackage() {
452 local NAME="$1"
453 local ARCH="$2"
454 local VERSION="$3"
455 local RELEASE="${4:-unstable}"
456 local DEPENDENCIES="$5"
457 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
458 If you find such a package installed on your system,
459 something went horribly wrong! They are autogenerated
460 und used only by testcases and surf no other propose…"}"
461
462 local SECTION="${7:-others}"
463 local PRIORITY="${8:-optional}"
464 local FILE_TREE="$9"
465 local COMPRESS_TYPE="${10:-gzip}"
466 local DISTSECTION
467 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
468 DISTSECTION="main"
469 else
470 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
471 fi
472 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
473
474 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
475 mkdir -p $BUILDDIR/debian/source
476 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
477 echo "#!/bin/sh
478 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
479
480 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
481 echo "$NAME ($VERSION) $RELEASE; urgency=low
482
483 * Initial release
484
485 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
486 echo "Source: $NAME
487 Section: $SECTION
488 Priority: $PRIORITY
489 Maintainer: Joe Sixpack <joe@example.org>
490 Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control
491 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
492 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
493 echo "
494 Package: $NAME" >> ${BUILDDIR}/debian/control
495
496 if [ "$ARCH" = 'all' ]; then
497 echo "Architecture: all" >> ${BUILDDIR}/debian/control
498 else
499 echo "Architecture: any" >> ${BUILDDIR}/debian/control
500 fi
501 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
502 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
503 echo "Description: $DESCRIPTION" >> ${BUILDDIR}/debian/control
504
505 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
506 (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' \
507 | while read SRC; do
508 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
509 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
510 # aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \
511 # adv --yes --default-key 'Joe Sixpack' \
512 # --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
513 # mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
514 # fi
515 done
516
517 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
518 rm -rf ${BUILDDIR}/debian/tmp
519 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
520 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
521 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
522 if [ -n "$FILE_TREE" ]; then
523 cp -ar "$FILE_TREE" ${BUILDDIR}/debian/tmp
524 fi
525
526 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
527 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
528 local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
529 # ensure the right permissions as dpkg-deb ensists
530 chmod 755 ${BUILDDIR}/debian/tmp/DEBIAN
531 if ! dpkg-deb -Z${COMPRESS_TYPE} --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. >$LOG 2>&1; then
532 cat $LOG
533 false
534 fi
535 rm $LOG
536 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
537 done
538
539 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
540 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
541 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
542 rm -rf "${BUILDDIR}"
543 msgdone "info"
544 }
545
546 buildpackage() {
547 local BUILDDIR=$1
548 local RELEASE=$2
549 local SECTION=$3
550 local ARCH=$(getarchitecture $4)
551 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
552 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
553 msgninfo "Build package ${PKGNAME} for ${RELEASE} in ${SECTION}… "
554 cd $BUILDDIR
555 if [ "$ARCH" = "all" ]; then
556 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
557 fi
558 if ! dpkg-buildpackage -uc -us -a$ARCH >$BUILDLOG 2>&1 ; then
559 cat $BUILDLOG
560 false
561 fi
562 local PKGS="$(grep '^dpkg-deb: building package' $BUILDLOG | cut -d'/' -f 2 | sed -e "s#'\.##")"
563 local SRCS="$(grep '^dpkg-source: info: building' $BUILDLOG | grep -o '[a-z0-9._+~-]*$')"
564 cd - > /dev/null
565 for PKG in $PKGS; do
566 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
567 done
568 for SRC in $SRCS; do
569 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
570 done
571 msgdone "info"
572 }
573
574 buildaptarchive() {
575 if [ -d incoming ]; then
576 buildaptarchivefromincoming "$@"
577 else
578 buildaptarchivefromfiles "$@"
579 fi
580 }
581
582 createaptftparchiveconfig() {
583 local COMPRESSORS="$(cut -d' ' -f 1 ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | tr '\n' ' ')"
584 COMPRESSORS="${COMPRESSORS%* }"
585 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
586 if [ -z "$ARCHS" ]; then
587 # the pool is empty, so we will operate on faked packages - let us use the configured archs
588 ARCHS="$(getarchitectures)"
589 fi
590 echo -n 'Dir {
591 ArchiveDir "' >> ftparchive.conf
592 echo -n $(readlink -f .) >> ftparchive.conf
593 echo -n '";
594 CacheDir "' >> ftparchive.conf
595 echo -n $(readlink -f ..) >> ftparchive.conf
596 echo -n '";
597 FileListDir "' >> ftparchive.conf
598 echo -n $(readlink -f pool/) >> ftparchive.conf
599 echo -n '";
600 };
601 Default {
602 Packages::Compress "'"$COMPRESSORS"'";
603 Sources::Compress "'"$COMPRESSORS"'";
604 Contents::Compress "'"$COMPRESSORS"'";
605 Translation::Compress "'"$COMPRESSORS"'";
606 LongDescription "false";
607 };
608 TreeDefault {
609 Directory "pool/";
610 SrcDirectory "pool/";
611 };
612 APT {
613 FTPArchive {
614 Release {
615 Origin "joesixpack";
616 Label "apttestcases";
617 Suite "unstable";
618 Description "repository with dummy packages";
619 Architectures "' >> ftparchive.conf
620 echo -n "$ARCHS" >> ftparchive.conf
621 echo 'source";
622 };
623 };
624 };' >> ftparchive.conf
625 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
626 echo -n 'tree "dists/' >> ftparchive.conf
627 echo -n "$DIST" >> ftparchive.conf
628 echo -n '" {
629 Architectures "' >> ftparchive.conf
630 echo -n "$ARCHS" >> ftparchive.conf
631 echo -n 'source";
632 FileList "' >> ftparchive.conf
633 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
634 echo -n '";
635 SourceFileList "' >> ftparchive.conf
636 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
637 echo -n '";
638 Sections "' >> ftparchive.conf
639 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
640 echo '";
641 };' >> ftparchive.conf
642 done
643 }
644
645 buildaptftparchivedirectorystructure() {
646 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
647 for DIST in $DISTS; do
648 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
649 for SECTION in $SECTIONS; do
650 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
651 for ARCH in $ARCHS; do
652 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
653 done
654 mkdir -p dists/${DIST}/${SECTION}/source
655 mkdir -p dists/${DIST}/${SECTION}/i18n
656 done
657 done
658 }
659
660 insertpackage() {
661 local RELEASES="$1"
662 local NAME="$2"
663 local ARCH="$3"
664 local VERSION="$4"
665 local DEPENDENCIES="$5"
666 local PRIORITY="${6:-optional}"
667 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASES}
668 If you find such a package installed on your system,
669 something went horribly wrong! They are autogenerated
670 und used only by testcases and surf no other propose…"}"
671 local ARCHS=""
672 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
673 if [ "$RELEASE" = 'installed' ]; then
674 insertinstalledpackage "$2" "$3" "$4" "$5" "$6" "$7"
675 continue
676 fi
677 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
678 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
679 ARCHS="$(getarchitectures)"
680 else
681 ARCHS="$arch"
682 fi
683 for BUILDARCH in $ARCHS; do
684 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
685 mkdir -p $PPATH
686 local FILE="${PPATH}/Packages"
687 echo "Package: $NAME
688 Priority: $PRIORITY
689 Section: other
690 Installed-Size: 42
691 Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
692 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
693 echo "Version: $VERSION
694 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
695 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
696 echo "Description: $(printf '%s' "$DESCRIPTION" | head -n 1)" >> $FILE
697 echo "Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)" >> $FILE
698 echo >> $FILE
699 done
700 done
701 mkdir -p aptarchive/dists/${RELEASE}/main/source aptarchive/dists/${RELEASE}/main/i18n
702 touch aptarchive/dists/${RELEASE}/main/source/Sources
703 echo "Package: $NAME
704 Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)
705 Description-en: $DESCRIPTION
706 " >> aptarchive/dists/${RELEASE}/main/i18n/Translation-en
707 done
708 }
709
710 insertsource() {
711 local RELEASE="$1"
712 local NAME="$2"
713 local ARCH="$3"
714 local VERSION="$4"
715 local DEPENDENCIES="$5"
716 local ARCHS=""
717 local SPATH="aptarchive/dists/${RELEASE}/main/source"
718 mkdir -p $SPATH
719 local FILE="${SPATH}/Sources"
720 echo "Package: $NAME
721 Binary: $NAME
722 Version: $VERSION
723 Maintainer: Joe Sixpack <joe@example.org>
724 Architecture: $ARCH" >> $FILE
725 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
726 echo "Files:
727 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
728 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz
729 " >> $FILE
730 }
731
732 insertinstalledpackage() {
733 local NAME="$1"
734 local ARCH="$2"
735 local VERSION="$3"
736 local DEPENDENCIES="$4"
737 local PRIORITY="${5:-optional}"
738 local STATUS="${6:-install ok installed}"
739 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
740 If you find such a package installed on your system,
741 something went horribly wrong! They are autogenerated
742 und used only by testcases and surf no other propose…"}"
743
744 local FILE='rootdir/var/lib/dpkg/status'
745 local INFO='rootdir/var/lib/dpkg/info'
746 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
747 echo "Package: $NAME
748 Status: $STATUS
749 Priority: $PRIORITY
750 Section: other
751 Installed-Size: 42
752 Maintainer: Joe Sixpack <joe@example.org>
753 Version: $VERSION" >> $FILE
754 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
755 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
756 echo "Description: $DESCRIPTION" >> $FILE
757 echo >> $FILE
758 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
759 echo -n > ${INFO}/${NAME}:${arch}.list
760 else
761 echo -n > ${INFO}/${NAME}.list
762 fi
763 done
764 }
765
766
767 buildaptarchivefromincoming() {
768 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
769 cd aptarchive
770 [ -e pool ] || ln -s ../incoming pool
771 [ -e ftparchive.conf ] || createaptftparchiveconfig
772 [ -e dists ] || buildaptftparchivedirectorystructure
773 msgninfo "\tGenerate Packages, Sources and Contents files… "
774 aptftparchive -qq generate ftparchive.conf
775 cd - > /dev/null
776 msgdone "info"
777 generatereleasefiles "$@"
778 }
779
780 buildaptarchivefromfiles() {
781 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
782 find aptarchive -name 'Packages' -o -name 'Sources' -o -name 'Translation-*' | while read line; do
783 msgninfo "\t${line} file… "
784 compressfile "$line" "$1"
785 msgdone "info"
786 done
787 generatereleasefiles "$@"
788 }
789
790 compressfile() {
791 cat ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | while read compressor extension command; do
792 if [ "$compressor" = '.' ]; then
793 if [ -n "$2" ]; then
794 touch -d "$2" "$1"
795 fi
796 continue
797 fi
798 cat "$1" | $command > "${1}.${extension}"
799 if [ -n "$2" ]; then
800 touch -d "$2" "${1}.${extension}"
801 fi
802 done
803 }
804
805 # can be overridden by testcases for their pleasure
806 getcodenamefromsuite() {
807 case "$1" in
808 unstable) echo 'sid';;
809 *) echo -n "$1";;
810 esac
811 }
812 getreleaseversionfromsuite() { true; }
813 getlabelfromsuite() { true; }
814
815 generatereleasefiles() {
816 # $1 is the Date header and $2 is the ValidUntil header to be set
817 # both should be given in notation date/touch can understand
818 msgninfo "\tGenerate Release files… "
819 if [ -e aptarchive/dists ]; then
820 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
821 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
822 local CODENAME="$(getcodenamefromsuite $SUITE)"
823 local VERSION="$(getreleaseversionfromsuite $SUITE)"
824 local LABEL="$(getlabelfromsuite $SUITE)"
825 if [ -n "$VERSION" ]; then
826 VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
827 fi
828 if [ -n "$LABEL" ]; then
829 LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
830 fi
831 aptftparchive -qq release $dir \
832 -o APT::FTPArchive::Release::Suite="${SUITE}" \
833 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
834 ${LABEL} \
835 ${VERSION} \
836 | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
837 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
838 sed -i '/^Date: / a\
839 NotAutomatic: yes' $dir/Release
840 fi
841 if [ -n "$1" -a "$1" != "now" ]; then
842 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
843 fi
844 if [ -n "$2" ]; then
845 sed -i "/^Date: / a\
846 Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
847 fi
848 done
849 else
850 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
851 fi
852 if [ -n "$1" -a "$1" != "now" ]; then
853 for release in $(find ./aptarchive -name 'Release'); do
854 touch -d "$1" $release
855 done
856 fi
857 msgdone "info"
858 }
859
860 setupdistsaptarchive() {
861 local APTARCHIVE=$(readlink -f ./aptarchive)
862 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
863 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
864 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
865 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
866 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
867 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
868 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
869 msgdone "info"
870 done
871 }
872
873 setupflataptarchive() {
874 local APTARCHIVE=$(readlink -f ./aptarchive)
875 if [ -f ${APTARCHIVE}/Packages ]; then
876 msgninfo "\tadd deb sources.list line… "
877 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
878 msgdone "info"
879 else
880 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
881 fi
882 if [ -f ${APTARCHIVE}/Sources ]; then
883 msgninfo "\tadd deb-src sources.list line… "
884 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
885 msgdone "info"
886 else
887 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
888 fi
889 }
890
891 setupaptarchive() {
892 local NOUPDATE=0
893 if [ "$1" = '--no-update' ]; then
894 NOUPDATE=1
895 shift
896 fi
897 buildaptarchive "$@"
898 if [ -e aptarchive/dists ]; then
899 setupdistsaptarchive
900 else
901 setupflataptarchive
902 fi
903 signreleasefiles 'Joe Sixpack'
904 if [ "1" != "$NOUPDATE" ]; then
905 testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true
906 fi
907 }
908
909 signreleasefiles() {
910 local SIGNER="${1:-Joe Sixpack}"
911 local REPODIR="${2:-aptarchive}"
912 local KEY="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | sed 's# ##g')"
913 local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes"
914 msgninfo "\tSign archive with $SIGNER key $KEY… "
915 local REXKEY='keys/rexexpired'
916 local SECEXPIREBAK="${REXKEY}.sec.bak"
917 local PUBEXPIREBAK="${REXKEY}.pub.bak"
918 if [ "${SIGNER}" = 'Rex Expired' ]; then
919 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
920 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
921 # therefore we 'temporary' make the key not expired and restore a backup after signing
922 cp ${REXKEY}.sec $SECEXPIREBAK
923 cp ${REXKEY}.pub $PUBEXPIREBAK
924 local SECUNEXPIRED="${REXKEY}.sec.unexpired"
925 local PUBUNEXPIRED="${REXKEY}.pub.unexpired"
926 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
927 cp $SECUNEXPIRED ${REXKEY}.sec
928 cp $PUBUNEXPIRED ${REXKEY}.pub
929 else
930 if ! printf "expire\n1w\nsave\n" | $GPG --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then
931 cat setexpire.gpg
932 exit 1
933 fi
934 cp ${REXKEY}.sec $SECUNEXPIRED
935 cp ${REXKEY}.pub $PUBUNEXPIRED
936 fi
937 fi
938 for RELEASE in $(find ${REPODIR}/ -name Release); do
939 $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg ${RELEASE}
940 local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
941 $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE
942 # we might have set a specific date for the Release file, so copy it
943 touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg ${INRELEASE}
944 done
945 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
946 mv -f $SECEXPIREBAK ${REXKEY}.sec
947 mv -f $PUBEXPIREBAK ${REXKEY}.pub
948 fi
949 msgdone "info"
950 }
951
952 webserverconfig() {
953 local NOCHECK=false
954 if [ "$1" = '--no-check' ]; then
955 NOCHECK=true
956 shift
957 fi
958 local DOWNLOG='rootdir/tmp/download-testfile.log'
959 local STATUS='downloaded/webserverconfig.status'
960 rm -f "$STATUS" "$DOWNLOG"
961 local URI
962 if [ -n "$2" ]; then
963 msgtest "Set webserver config option '${1}' to" "$2"
964 URI="http://localhost:8080/_config/set/${1}/${2}"
965 else
966 msgtest 'Clear webserver config option' "${1}"
967 URI="http://localhost:8080/_config/clear/${1}"
968 fi
969 if downloadfile "$URI" "$STATUS" > "$DOWNLOG"; then
970 msgpass
971 else
972 cat "$DOWNLOG" "$STATUS" || true
973 msgfail
974 fi
975 $NOCHECK || testwebserverlaststatuscode '200'
976 }
977
978 rewritesourceslist() {
979 local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive")"
980 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
981 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#http://localhost:8080/#${1}#" -e "s#https://localhost:4433/#${1}#"
982 done
983 }
984
985 # wait for up to 10s for a pid file to appear to avoid possible race
986 # when a helper is started and dosn't write the PID quick enough
987 waitforpidfile() {
988 local PIDFILE="$1"
989 for i in $(seq 10); do
990 if test -s "$PIDFILE"; then
991 return 0
992 fi
993 sleep 1
994 done
995 msgdie "waiting for $PIDFILE failed"
996 return 1
997 }
998
999 changetowebserver() {
1000 if [ "$1" != '--no-rewrite' ]; then
1001 rewritesourceslist 'http://localhost:8080/'
1002 else
1003 shift
1004 fi
1005 if test -x ${APTWEBSERVERBINDIR}/aptwebserver; then
1006 cd aptarchive
1007 local LOG="webserver.log"
1008 if ! aptwebserver -o aptwebserver::fork=1 "$@" >$LOG 2>&1 ; then
1009 cat $LOG
1010 false
1011 fi
1012 waitforpidfile aptwebserver.pid
1013 local PID="$(cat aptwebserver.pid)"
1014 if [ -z "$PID" ]; then
1015 msgdie 'Could not fork aptwebserver successfully'
1016 fi
1017 addtrap "kill $PID;"
1018 cd - > /dev/null
1019 else
1020 msgdie 'You have to build aptwerbserver or install a webserver'
1021 fi
1022 }
1023
1024 changetohttpswebserver() {
1025 if ! which stunnel4 >/dev/null; then
1026 msgdie 'You need to install stunnel4 for https testcases'
1027 fi
1028 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
1029 changetowebserver --no-rewrite "$@"
1030 fi
1031 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
1032 cert = ${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem
1033 output = /dev/null
1034
1035 [https]
1036 accept = 4433
1037 connect = 8080
1038 " > ${TMPWORKINGDIRECTORY}/stunnel.conf
1039 stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf"
1040 waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
1041 local PID="$(cat ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid)"
1042 if [ -z "$PID" ]; then
1043 msgdie 'Could not fork stunnel4 successfully'
1044 fi
1045 addtrap 'prefix' "kill ${PID};"
1046 rewritesourceslist 'https://localhost:4433/'
1047 }
1048
1049 changetocdrom() {
1050 mkdir -p rootdir/media/cdrom/.disk
1051 local CD="$(readlink -f rootdir/media/cdrom)"
1052 echo "acquire::cdrom::mount \"${CD}\";
1053 acquire::cdrom::${CD}/::mount \"mv ${CD}-unmounted ${CD}\";
1054 acquire::cdrom::${CD}/::umount \"mv ${CD} ${CD}-unmounted\";
1055 acquire::cdrom::autodetect 0;" > rootdir/etc/apt/apt.conf.d/00cdrom
1056 echo -n "$1" > ${CD}/.disk/info
1057 if [ ! -d aptarchive/dists ]; then
1058 msgdie 'Flat file archive cdroms can not be created currently'
1059 return 1
1060 fi
1061 mv aptarchive/dists "$CD"
1062 ln -s "$(readlink -f ./incoming)" $CD/pool
1063 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
1064 # start with an unmounted disk
1065 mv "${CD}" "${CD}-unmounted"
1066 # we don't want the disk to be modifiable
1067 addtrap 'prefix' "chmod -f -R +w $PWD/rootdir/media/cdrom/dists/ $PWD/rootdir/media/cdrom-unmounted/dists/ || true;"
1068 chmod -R 555 rootdir/media/cdrom-unmounted/dists
1069 }
1070
1071 downloadfile() {
1072 local PROTO="$(echo "$1" | cut -d':' -f 1 )"
1073 apthelper -o Debug::Acquire::${PROTO}=1 \
1074 download-file "$1" "$2" 2>&1 || true
1075 # only if the file exists the download was successful
1076 if [ -r "$2" ]; then
1077 return 0
1078 else
1079 return 1
1080 fi
1081 }
1082
1083 checkdiff() {
1084 local DIFFTEXT="$(command diff -u "$@" 2>&1 | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
1085 if [ -n "$DIFFTEXT" ]; then
1086 echo >&2
1087 echo >&2 "$DIFFTEXT"
1088 return 1
1089 else
1090 return 0
1091 fi
1092 }
1093
1094 testfileequal() {
1095 local FILE="$1"
1096 shift
1097 msgtest "Test for correctness of file" "$FILE"
1098 if [ -z "$*" ]; then
1099 echo -n "" | checkdiff $FILE - && msgpass || msgfail
1100 else
1101 echo "$*" | checkdiff $FILE - && msgpass || msgfail
1102 fi
1103 }
1104
1105 testempty() {
1106 msgtest "Test for no output of" "$*"
1107 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
1108 if "$@" >$COMPAREFILE 2>&1 && test ! -s $COMPAREFILE; then
1109 msgpass
1110 else
1111 cat $COMPAREFILE
1112 msgfail
1113 fi
1114 aptautotest 'testempty' "$@"
1115 }
1116
1117 testequal() {
1118 local MSG='Test of equality of'
1119 if [ "$1" = '--nomsg' ]; then
1120 MSG=''
1121 shift
1122 fi
1123
1124 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
1125 echo "$1" > $COMPAREFILE
1126 shift
1127
1128 if [ -n "$MSG" ]; then
1129 msgtest "$MSG" "$*"
1130 fi
1131 "$@" 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
1132 aptautotest 'testequal' "$@"
1133 }
1134
1135 testequalor2() {
1136 local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1137 local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1138 local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
1139 echo "$1" > $COMPAREFILE1
1140 echo "$2" > $COMPAREFILE2
1141 shift 2
1142 msgtest "Test for equality OR of" "$*"
1143 "$@" >$COMPAREAGAINST 2>&1 || true
1144 if checkdiff $COMPAREFILE1 $COMPAREAGAINST >/dev/null 2>&1 || \
1145 checkdiff $COMPAREFILE2 $COMPAREAGAINST >/dev/null 2>&1
1146 then
1147 msgpass
1148 else
1149 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}"
1150 checkdiff $COMPAREFILE1 $COMPAREAGAINST || true
1151 echo -n "${CINFO}Diff against OR 2${CNORMAL}"
1152 checkdiff $COMPAREFILE2 $COMPAREAGAINST || true
1153 msgfail
1154 fi
1155 aptautotest 'testequalor2' "$@"
1156 }
1157
1158 testshowvirtual() {
1159 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
1160 local PACKAGE="$1"
1161 shift
1162 while [ -n "$1" ]; do
1163 VIRTUAL="${VIRTUAL}
1164 N: Can't select versions from package '$1' as it is purely virtual"
1165 PACKAGE="${PACKAGE} $1"
1166 shift
1167 done
1168 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
1169 VIRTUAL="${VIRTUAL}
1170 N: No packages found"
1171 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
1172 local ARCH="$(getarchitecture 'native')"
1173 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
1174 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
1175 }
1176
1177 testnopackage() {
1178 msgtest "Test for non-existent packages" "apt-cache show $*"
1179 local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
1180 if [ -n "$SHOWPKG" ]; then
1181 echo >&2
1182 echo >&2 "$SHOWPKG"
1183 msgfail
1184 else
1185 msgpass
1186 fi
1187 }
1188
1189 testdpkginstalled() {
1190 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
1191 local PKGS="$(dpkg -l "$@" 2>/dev/null | grep '^i' | wc -l)"
1192 if [ "$PKGS" != $# ]; then
1193 echo >&2 $PKGS
1194 dpkg -l "$@" | grep '^[a-z]' >&2
1195 msgfail
1196 else
1197 msgpass
1198 fi
1199 }
1200
1201 testdpkgnotinstalled() {
1202 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
1203 local PKGS="$(dpkg -l "$@" 2> /dev/null | grep '^i' | wc -l)"
1204 if [ "$PKGS" != 0 ]; then
1205 echo
1206 dpkg -l "$@" | grep '^[a-z]' >&2
1207 msgfail
1208 else
1209 msgpass
1210 fi
1211 }
1212
1213 testmarkedauto() {
1214 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
1215 if [ -n "$1" ]; then
1216 msgtest 'Test for correctly marked as auto-installed' "$*"
1217 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1218 else
1219 msgtest 'Test for correctly marked as auto-installed' 'no package'
1220 echo -n > $COMPAREFILE
1221 fi
1222 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
1223 }
1224
1225 msgfailoutput() {
1226 local MSG="$1"
1227 local OUTPUT="$2"
1228 shift 2
1229 echo >&2
1230 if [ "$1" = 'grep' ]; then
1231 while [ -n "$2" ]; do shift; done
1232 echo "#### Complete file: $1 ####"
1233 cat >&2 "$1" || true
1234 echo '#### grep output ####'
1235 elif [ "$1" = 'test' ]; then
1236 # doesn't support ! or non-file flags
1237 msgfailoutputstatfile() {
1238 local FILEFLAGS='^-[bcdefgGhkLOprsStuwx]$'
1239 if expr match "$1" "$FILEFLAGS" >/dev/null; then
1240 echo "#### stat(2) of file: $2 ####"
1241 stat "$2" || true
1242 fi
1243 }
1244 msgfailoutputstatfile "$2" "$3"
1245 while [ -n "$5" ] && [ "$4" = '-o' -o "$4" = '-a' ]; do
1246 shift 3
1247 msgfailoutputstatfile "$2" "$3"
1248 done
1249 echo '#### test output ####'
1250 fi
1251 cat >&2 $OUTPUT
1252 msgfail "$MSG"
1253 }
1254
1255 testsuccess() {
1256 if [ "$1" = '--nomsg' ]; then
1257 shift
1258 else
1259 msgtest 'Test for successful execution of' "$*"
1260 fi
1261 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output"
1262 if "$@" >${OUTPUT} 2>&1; then
1263 if expr match "$1" '^apt.*' >/dev/null; then
1264 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1265 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1266 elif grep -q -E '^[WE]: ' "$OUTPUT"; then
1267 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1268 else
1269 msgpass
1270 fi
1271 else
1272 msgpass
1273 fi
1274 else
1275 local EXITCODE=$?
1276 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1277 fi
1278 aptautotest 'testsuccess' "$@"
1279 }
1280 testwarning() {
1281 if [ "$1" = '--nomsg' ]; then
1282 shift
1283 else
1284 msgtest 'Test for successful execution with warnings of' "$*"
1285 fi
1286 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output"
1287 if "$@" >${OUTPUT} 2>&1; then
1288 if expr match "$1" '^apt.*' >/dev/null; then
1289 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1290 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1291 elif grep -q -E '^E: ' "$OUTPUT"; then
1292 msgfailoutput 'successful run, but output contains errors' "$OUTPUT" "$@"
1293 elif ! grep -q -E '^W: ' "$OUTPUT"; then
1294 msgfailoutput 'successful run, but output contains no warnings' "$OUTPUT" "$@"
1295 else
1296 msgpass
1297 fi
1298 else
1299 msgpass
1300 fi
1301 else
1302 local EXITCODE=$?
1303 echo >&2
1304 cat >&2 $OUTPUT
1305 msgfail "exitcode $EXITCODE"
1306 fi
1307 aptautotest 'testwarning' "$@"
1308 }
1309 testfailure() {
1310 if [ "$1" = '--nomsg' ]; then
1311 shift
1312 else
1313 msgtest 'Test for failure in execution of' "$*"
1314 fi
1315 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
1316 if "$@" >${OUTPUT} 2>&1; then
1317 local EXITCODE=$?
1318 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1319 else
1320 local EXITCODE=$?
1321 if expr match "$1" '^apt.*' >/dev/null; then
1322 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1323 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1324 elif ! grep -q -E '^E: ' "$OUTPUT"; then
1325 msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@"
1326 else
1327 msgpass
1328 fi
1329 else
1330 msgpass
1331 fi
1332 fi
1333 aptautotest 'testfailure' "$@"
1334 }
1335
1336 testfilestats() {
1337 msgtest "Test that file $1 has $2 $3" "$4"
1338 if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then
1339 msgpass
1340 else
1341 echo >&2
1342 ls -l >&2 "$1"
1343 echo -n >&2 "stat(1) reports for $2: "
1344 stat --format "$2" "$1"
1345 msgfail
1346 fi
1347 }
1348 testaccessrights() {
1349 testfilestats "$1" '%a' '=' "$2"
1350 }
1351
1352 testwebserverlaststatuscode() {
1353 local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
1354 local STATUS='downloaded/webserverstatus-statusfile.log'
1355 rm -f "$DOWNLOG" "$STATUS"
1356 msgtest 'Test last status code from the webserver was' "$1"
1357 if downloadfile "http://localhost:8080/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then
1358 msgpass
1359 else
1360 echo >&2
1361 if [ -n "$2" ]; then
1362 shift
1363 echo >&2 '#### Additionally provided output files contain:'
1364 cat >&2 "$@"
1365 fi
1366 echo >&2 '#### Download log of the status code:'
1367 cat >&2 "$DOWNLOG"
1368 msgfail "Status was $(cat "$STATUS")"
1369 fi
1370 }
1371
1372 pause() {
1373 echo "STOPPED execution. Press enter to continue"
1374 local IGNORE
1375 read IGNORE
1376 }
1377
1378 listcurrentlistsdirectory() {
1379 find rootdir/var/lib/apt/lists -maxdepth 1 -type d | while read line; do
1380 stat --format '%U:%G:%a:%n' "$line"
1381 done
1382 find rootdir/var/lib/apt/lists -maxdepth 1 \! -type d | while read line; do
1383 stat --format '%U:%G:%a:%s:%y:%n' "$line"
1384 done
1385 }
1386
1387 ### The following tests are run by most test methods automatically to check
1388 ### general things about commands executed without writing the test every time.
1389
1390 aptautotest() {
1391 local TESTCALL="$1"
1392 local CMD="$2"
1393 local FIRSTOPT="$3"
1394 local AUTOTEST="aptautotest_$(basename "$CMD" | tr -d '-')_$(echo "$FIRSTOPT" | tr -d '-')"
1395 if command -v $AUTOTEST >/dev/null; then
1396 shift 3
1397 # save and restore the *.output files from other tests
1398 # as we might otherwise override them in these automatic tests
1399 rm -rf ${TMPWORKINGDIRECTORY}/rootdir/tmp-before
1400 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp ${TMPWORKINGDIRECTORY}/rootdir/tmp-before
1401 mkdir ${TMPWORKINGDIRECTORY}/rootdir/tmp
1402 $AUTOTEST "$TESTCALL" "$@"
1403 rm -rf ${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest
1404 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp ${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest
1405 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp-before ${TMPWORKINGDIRECTORY}/rootdir/tmp
1406 fi
1407 }
1408
1409 aptautotest_aptget_update() {
1410 if ! test -d "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"; then return; fi
1411 # all copied files are properly chmodded
1412 for file in $(find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" -maxdepth 1 -type f); do
1413 testfilestats "$file" '%U:%G:%a' '=' "${USER}:${USER}:644"
1414 done
1415 }
1416 aptautotest_apt_update() { aptautotest_aptget_update "$@"; }